<?php
namespace PME\Controllers\Requisicao;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class CalcPrevConsController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $birtStrategy;
    protected $environment;
    protected $lista;
    protected $utilities;
    protected $newCode;

    public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $environment, $lista, $utilities, $newCode, $connection) {
        $this->entityManager = $entityManager;
        $this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
        $this->lista = $lista;
        $this->utilities = $utilities;
        $this->newCode = $newCode;
        $this->connection = $connection;

        parent::__construct($reportService);
    }

    protected $reportMapping = array (
      'PME00800' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "PRODINI"        => "P_PRODINI",
            "PRODFIN"        => "P_PRODFIN",
            "CDPRODINI"      => "P_CDPRODINI",
            "CDPRODFIN"      => "P_CDPRODFIN",
            "NMPRODINI"      => "P_NMPRODINI",
            "NMPRODFIN"      => "P_NMPRODFIN",
            "ORDENA"         => "P_ORDENA",
            "ARREDONDAMENTO" => "P_STARREDONDA",
            "ACRESCIMO"      => "P_ACRECIMO",
            "TAMACNIVEL"     => "P_TAMACNIVEL",
            "TAMCODIGO"      => "P_TAMCODIGO",
            "NRORG"          => "P_NRORG",
            "IDSUBGRUP"      => "P_IDSUBGRUP",
            "CDFILCENTPME"   => "P_CDFILCENTPME",
            "DTDE"           => "P_DTPERIINI",
            "DTATE"          => "P_DTPERIFIN",
            "CDGRUPPROD"     => "P_CDGRUPPROD",
            "CDFILCENTCMP"   => "P_CDFILCENTCMP",
            "LISTASERVICO"   => "L_CDSERVFILI",
            "LISTATIPOCARD"  => "L_CDTIPOCARD",
            "LISTASUBGRPROD" => "L_CDSUBGRPROD",
            "IMPFILTRO"      => "P_IMPFILTRO",
            "IMPSERV"        => "P_IMPSERV",
            "NMFILCENTPME"   => "P_NMFILCENTPME",
            "PRODUCTMASK"    => "P_PRODUCTMASK",
            "TSERVICOS"      => "P_TSERVICOS",
            "TUNIDADES"      => "P_TUNIDADES",
            "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
      'PME00801' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "PRODINI"        => "P_PRODINI",
              "PRODFIN"        => "P_PRODFIN",
              "CDPRODINI"      => "P_CDPRODINI",
              "CDPRODFIN"      => "P_CDPRODFIN",
              "NMPRODINI"      => "P_NMPRODINI",
              "NMPRODFIN"      => "P_NMPRODFIN",
              "CDTIPOCUSTO"    => "P_TIPOCUSTO",
              "NMTIPOCUSTO"    => "P_NMTIPOCUSTO",
              "ORDENA"         => "P_ORDENA",
              "IMPFILTRO"      => "P_IMPFILTRO",
              "IMPSERV"        => "P_IMPSERV",
              "ARREDONDAMENTO" => "P_STARREDONDA",
              "ACRESCIMO"      => "P_ACRECIMO",
              "TAMACNIVEL"     => "P_TAMACNIVEL",
              "TAMCODIGO"      => "P_TAMCODIGO",
              "NRORG"          => "P_NRORG",
              "IDSUBGRUP"      => "P_IDSUBGRUP",
              "CDFILCENTPME"   => "P_CDFILCENTPME",
              "NMFILCENTPME"   => "P_NMFILCENTPME",
              "DTDE"           => "P_DTPERIINI",
              "DTATE"          => "P_DTPERIFIN",
              "CDGRUPPROD"     => "P_CDGRUPPROD",
              "CDFILCENTCMP"   => "P_CDFILCENTCMP",
              "LISTASERVICO"   => "L_CDSERVFILI",
              "LISTATIPOCARD"  => "L_CDTIPOCARD",
              "LISTASUBGRPROD" => "L_CDSUBGRPROD",
              "PRODUCTMASK"    => "P_PRODUCTMASK",
              "TSERVICOS"      => "P_TSERVICOS",
              "TUNIDADES"      => "P_TUNIDADES",
              "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
      'PME00802' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "PRODINI"        => "P_PRODINI",
              "PRODFIN"        => "P_PRODFIN",
              "CDPRODINI"      => "P_CDPRODINI",
              "CDPRODFIN"      => "P_CDPRODFIN",
              "NMPRODINI"      => "P_NMPRODINI",
              "NMPRODFIN"      => "P_NMPRODFIN",
              "CDTIPOCUSTO"    => "P_TIPOCUSTO",
              "NMTIPOCUSTO"    => "P_NMTIPOCUSTO",
              "ORDENA"         => "P_ORDENA",
              "IMPFILTRO"      => "P_IMPFILTRO",
              "IMPSERV"        => "P_IMPSERV",
              "ARREDONDAMENTO" => "P_STARREDONDA",
              "ACRESCIMO"      => "P_ACRECIMO",
              "TAMACNIVEL"     => "P_TAMACNIVEL",
              "TAMCODIGO"      => "P_TAMCODIGO",
              "NRORG"          => "P_NRORG",
              "IDSUBGRUP"      => "P_IDSUBGRUP",
              "CDFILCENTPME"   => "P_CDFILCENTPME",
              "NMFILCENTPME"   => "P_NMFILCENTPME",
              "DTDE"           => "P_DTPERIINI",
              "DTATE"          => "P_DTPERIFIN",
              "CDGRUPPROD"     => "P_CDGRUPPROD",
              "CDFILCENTCMP"   => "P_CDFILCENTCMP",
              "LISTASERVICO"   => "L_CDSERVFILI",
              "LISTATIPOCARD"  => "L_CDTIPOCARD",
              "LISTASUBGRPROD" => "L_CDSUBGRPROD",
              "PRODUCTMASK"    => "P_PRODUCTMASK",
              "TSERVICOS"      => "P_TSERVICOS",
              "TUNIDADES"      => "P_TUNIDADES",
              "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
      'PME00803' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "PRODINI"        => "P_PRODINI",
              "PRODFIN"        => "P_PRODFIN",
              "CDPRODINI"      => "P_CDPRODINI",
              "CDPRODFIN"      => "P_CDPRODFIN",
              "NMPRODINI"      => "P_NMPRODINI",
              "NMPRODFIN"      => "P_NMPRODFIN",
              "CDTIPOCUSTO"    => "P_NRTIPOCUST",
              "NMTIPOCUSTO"    => "P_NMTIPOCUSTO",
              "ORDENA"         => "P_ORDENA",
              "IMPFILTRO"      => "P_IMPFILTRO",
              "IMPSERV"        => "P_IMPSERV",
              "ARREDONDAMENTO" => "P_STARREDONDA",
              "ACRESCIMO"      => "P_ACRECIMO",
              "TAMACNIVEL"     => "P_TAMACNIVEL",
              "TAMCODIGO"      => "P_TAMCODIGO",
              "NRORG"          => "P_NRORG",
              "IDSUBGRUP"      => "P_IDSUBGRUP",
              "CDFILCENTPME"   => "P_CDFILCENTPME",
              "NMFILCENTPME"   => "P_NMFILCENTPME",
              "DTDE"           => "P_DTPERIINI",
              "DTATE"          => "P_DTPERIFIN",
              "CDGRUPPROD"     => "P_CDGRUPPROD",
              "CDFILCENTCMP"   => "P_CDFILCENTCMP",
              "LISTASERVICO"   => "L_CDSERVFILI",
              "LISTATIPOCARD"  => "L_CDTIPOCARD",
              "LISTASUBGRPROD" => "L_CDSUBGRPROD",
              "PRODUCTMASK"    => "P_PRODUCTMASK",
              "TSERVICOS"      => "P_TSERVICOS",
              "TUNIDADES"      => "P_TUNIDADES",
              "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
      'PME00805' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "PRODINI"        => "P_PRODINI",
              "PRODFIN"        => "P_PRODFIN",
              "CDPRODINI"      => "P_CDPRODINI",
              "CDPRODFIN"      => "P_CDPRODFIN",
              "NMPRODINI"      => "P_NMPRODINI",
              "NMPRODFIN"      => "P_NMPRODFIN",
              "CDTIPOCUSTO"    => "P_TIPOCUSTO",
              "NMTIPOCUSTO"    => "P_NMTIPOCUSTO",
              "ORDENA"         => "P_ORDENA",
              "IMPFILTRO"      => "P_IMPFILTRO",
              "IMPSERV"        => "P_IMPSERV",
              "ARREDONDAMENTO" => "P_STARREDONDA",
              "ACRESCIMO"      => "P_ACRECIMO",
              "TAMACNIVEL"     => "P_TAMACNIVEL",
              "TAMCODIGO"      => "P_TAMCODIGO",
              "NRORG"          => "P_NRORG",
              "IDSUBGRUP"      => "P_IDSUBGRUP",
              "CDFILCENTPME"   => "P_CDFILCENTPME",
              "NMFILCENTPME"   => "P_NMFILCENTPME",
              "DTDE"           => "P_DTPERIINI",
              "DTATE"          => "P_DTPERIFIN",
              "CDGRUPPROD"     => "P_CDGRUPPROD",
              "CDFILCENTCMP"   => "P_CDFILCENTCMP",
              "LISTASERVICO"   => "L_CDSERVFILI",
              "LISTATIPOCARD"  => "L_CDTIPOCARD",
              "LISTASUBGRPROD" => "L_CDSUBGRPROD",
              "PRODUCTMASK"    => "P_PRODUCTMASK",
              "TSERVICOS"      => "P_TSERVICOS",
              "TUNIDADES"      => "P_TUNIDADES",
              "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
      'PME00806' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "PRODINI"        => "P_PRODINI",
              "PRODFIN"        => "P_PRODFIN",
              "CDPRODINI"      => "P_CDPRODINI",
              "CDPRODFIN"      => "P_CDPRODFIN",
              "NMPRODINI"      => "P_NMPRODINI",
              "NMPRODFIN"      => "P_NMPRODFIN",
              "CDTIPOCUSTO"    => "P_NRTIPOCUST",
              "NMTIPOCUSTO"    => "P_NMTIPOCUSTO",
              "ORDENA"         => "P_ORDENA",
              "IMPFILTRO"      => "P_IMPFILTRO",
              "IMPSERV"        => "P_IMPSERV",
              "ARREDONDAMENTO" => "P_STARREDONDA",
              "ACRESCIMO"      => "P_ACRECIMO",
              "TAMACNIVEL"     => "P_TAMACNIVEL",
              "TAMCODIGO"      => "P_TAMCODIGO",
              "NRORG"          => "P_NRORG",
              "IDSUBGRUP"      => "P_IDSUBGRUP",
              "CDFILCENTPME"   => "P_CDFILCENTPME",
              "NMFILCENTPME"   => "P_NMFILCENTPME",
              "DTDE"           => "P_DTPERIINI",
              "DTATE"          => "P_DTPERIFIN",
              "CDGRUPPROD"     => "P_CDGRUPPROD",
              "CDFILCENTCMP"   => "P_CDFILCENTCMP",
              "LISTASERVICO"   => "L_CDSERVFILI",
              "LISTATIPOCARD"  => "L_CDTIPOCARD",
              "LISTASUBGRPROD" => "L_CDSUBGRPROD",
              "PRODUCTMASK"    => "P_PRODUCTMASK",
              "TSERVICOS"      => "P_TSERVICOS",
              "TUNIDADES"      => "P_TUNIDADES",
              "AGRUPNIVEL"     => "P_AGRUPNIVEL",
            )
        ),
    );

    public function beforeGenerateReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      
      if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('ACRESCIMO', $row)) $row['ACRESCIMO'] = 0;
      
      // if($row['CALCULAR']) $this->calculatePrevCons($request, $response);
      // else {
      set_time_limit(240);
      ini_set('memory_limit', '3072M');
      // }
              
      $nrorg = $this->environment->getNrOrg();

      // $servicos = join('_', $this->getServicos($row));

      // if(empty($row['TIPOCARD'])){
      //   $tipoCard = join('_', $this->getTipoCard($row));
      // }else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
      
      $subGrupProd = '';
      if(!empty($row['SUBGRUPPROD'])){
        foreach($row['SUBGRUPPROD'] as $element){
          $subGrupProd .= $element['CDSUBGRPROD'].'_';
        }
        $row['CDGRUPPROD'] = $row['SUBGRUPPROD'][0]['CDGRUPPROD'];
      }else{
        $row['SUBGRUPPROD'] = null;
        $row['CDGRUPPROD'] = null;
      }
      
      // $row['LISTASERVICO'] = $this->lista->geraLista($servicos, $nrorg);
      $row['LISTASERVICO'] = $this->geraListaServicos($row);
      
      // $row['LISTATIPOCARD'] = $this->lista->geraLista($tipoCard, $nrorg);
      $row['LISTATIPOCARD'] = $this->geraListaTipoCard($row);
      
      if(!empty($subGrupProd)){
        $row['IDSUBGRUP'] = 'S';
        $row['LISTASUBGRPROD'] = $this->lista->geraLista($subGrupProd, $nrorg);
      }else{
        $row['LISTASUBGRPROD'] = null;
        $row['IDSUBGRUP'] = 'N';
      }
      
      if($row['SERVICO'] == null) $row['TSERVICOS'] = 'T';
      else if(count($row['SERVICO']) == 1) {
        $cdservico = $row['SERVICO'][0];
        $cdcentral = $row['CDFILCENTPME'];
        // $descricaoServico = $this->returnDescricaoServico($cdservico, $tipoCard, $cdcentral)[0]['DESCRICAO'];
        if (empty($row['TIPOCARD'])) $card = 'T';
        else $card = $row['TIPOCARD'];
        $descricaoServico = $this->returnDescricaoServico($cdservico, $card, $cdcentral)[0]['DESCRICAO'];
        $row['TSERVICOS'] = $descricaoServico;
      }
      else $row['TSERVICOS'] = 'V';
      
      if($row['UNIDADE'] == null) $row['TUNIDADES'] = 'T';
      else if(count($row['UNIDADE']) == 1) {
         $cdfilial = $row['UNIDADE'][0];
         $descricaoFilial = $this->returnDescricaoFilial($cdfilial)[0]['DESCRICAO'];
         $row['TUNIDADES'] = $descricaoFilial;
      }
      else $row['TUNIDADES'] = 'V';

      if($row['ORDENA'] == 0) $row['TAMCODIGO'] = 10;
      else $row['TAMCODIGO'] = 0;
      
      $row['NRORG'] = $nrorg;
      $row['CDFILCENTCMP'] = null;
      
      $this->formatProd($row);
      
      $response->addDataSet(new DataSet('row', array($row)));
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      // $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
      $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
    
    private function formatProd($row){
      if(empty($row['PRODINICIAL']['CDARVPROD'])){
        $row['CDPRODINI'] = '0';
        $row['NMPRODINI'] = 'Todos';
        $row['PRODINI'] = ' ';
      }else {
        $row['CDPRODINI'] = $row['PRODINICIAL']['CDARVPROD'];
        $row['NMPRODINI'] = $row['PRODINICIAL']['NMPRODUTO'];
        $row['PRODINI'] = $row['PRODINICIAL']['CDARVPROD'];
      }

      if(empty($row['PRODFINAL']['CDARVPROD'])){
        $row['CDPRODFIN'] = 'zzzzzzzzzzz';
        $row['NMPRODFIN'] = 'Todos';
        $row['PRODFIN'] = ' ';
      }else{
        $row['CDPRODFIN'] = str_pad($row['PRODFINAL']['CDARVPROD'], 10, 'z');
        $row['NMPRODFIN'] = $row['PRODFINAL']['NMPRODUTO'];
        $row['PRODFIN'] = $row['PRODFINAL']['CDARVPROD'];
      }
    }
    
    public function returnDescricaoServico($cdservico, $tipocard, $cdcentral) {
        $sql = " SELECT DISTINCT
                      ST.CDSERVFILI,
                      S.NMSERVICO,
                      ST.CDSERVFILI
                      || ' - '
                      || S.NMSERVICO AS DESCRICAO,
                      S.NRORG
                  FROM
                      SERVTIPOCARD   ST
                      INNER JOIN SERVICO        S ON S.CDFILIAL = ST.CDFILCENTPME
                                              AND S.CDSERVFILI = ST.CDSERVFILI
                                              AND S.IDTIPOSERV = 'M'
                  WHERE ST.CDFILCENTPME = :CDFILCENTPME
                      AND ( INSTR(:CDTIPOCARD, ST.CDTIPOCARD) <> 0 OR :CDTIPOCARD = 'T' )
                      AND S.CDSERVFILI = :CDSERVFILI
                  ORDER BY
                      ST.CDSERVFILI";
                      
        if(empty($tipocard)) $cdtipocard = 'T';
        else $cdtipocard = is_array($tipocard) ? join("_", $tipocard) : $tipocard;
        
        $params = array(
            'CDFILCENTPME' => $cdcentral,
            'CDTIPOCARD' => $cdtipocard,
            'CDSERVFILI' => $cdservico
        );
        
        try {
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
   }
    
    public function returnDescricaoFilial($cdfilial) {
      $sql = "SELECT F.CDFILIAL || ' ' || F.NMFILIAL AS DESCRICAO, F.NRORG FROM FILIAL F WHERE F.CDFILIAL = :CDFILIAL";
      $params = array(
        'CDFILIAL' => $cdfilial
      );

      try {
        return $this->entityManager->getConnection()->fetchAll($sql, $params);
      } catch (\Exception $e) {
        throw $e;
      }
   }

    public function calculatePrevCons(DTO\Request\Row $request, DTO\Response $response) {
      try{
        $row = $request->getRow();
        
        $this->connection->beginTransaction();
        
        if(empty($row['CDARVPRODINI'])) $row['CDARVPRODINI'] = 0;

        if(empty($row['CDARVPRODFIN'])) $row['CDARVPRODFIN'] = "ZZZZZZZZZZ";
        else $row['CDARVPRODFIN'] = str_pad($row['CDARVPRODFIN'], 10, "Z", STR_PAD_RIGHT);
        
        $nrconsplan = $this->procedurePrevCons($row);
        
        $this->insertIntoLogprevconspme($row, $nrconsplan);
        $this->connection->commit();
      } catch (\Exception $e) {
      	$this->connection->rollback();
        $response->setError(new DTO\Response\Error($e->getMessage(), 1));
      }
    }

    private function procedurePrevCons($row){
      try {
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();
        $nrconsplan = $this->newCode->getCodeByTableName('CONSPLAN'.$row['CDFILCENTPME'], $nrorg);
        
        if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('GRUPFILI', $row)) {
          if(empty($row['UNIDADE'])) $cdfilial = join('_', $this->getUnidades($row));
          else $cdfilial = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];
        } else {
          if(empty($row['UNIDADE']) && empty($row['GRUPFILI'])) $cdfilial = join('_', $this->getUnidades($row));
          else if (empty($row['UNIDADE']) && !empty($row['GRUPFILI'])) $cdfilial = join('_', $this->getUnidadesAgrup($row));
          else $cdfilial = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];
        }
        
        if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('GRUPSERV', $row)) {
          if(empty($row['SERVICO'])) $cdservfili = join('_', $this->utilities->getDistinctServicos($row['CDFILCENTPME'], $row['UNIDADE'], "S"));
          else $cdservfili = is_array($row['SERVICO']) ? join("_", $row['SERVICO']) : $row['SERVICO'];
        } else {
          if(empty($row['SERVICO']) && empty($row['GRUPSERV'])) $cdservfili = join('_', $this->utilities->getDistinctServicos($row['CDFILCENTPME'], $row['UNIDADE'], "S"));
          else if (empty($row['SERVICO']) && !empty($row['GRUPSERV'])) $cdservfili = join('_', $this->utilities->getDistinctServicosGrup($row['CDFILCENTPME'], $row['UNIDADE'], $row["GRUPSERV"], "S"));
          else $cdservfili = is_array($row['SERVICO']) ? join("_", $row['SERVICO']) : $row['SERVICO'];
        }
        
        if(empty($row['TIPOCARD'])) $tipoCard = join('_', $this->getTipoCard($row));
        else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
        
        $cdprodIni = isset($row['PRODINICIAL']['CDARVPROD']) ? $row['PRODINICIAL']['CDARVPROD'] : 0;
        if(!(isset($row['PRODFINAL']['CDARVPROD']))) $cdprodFin = 'zzzzzzzzzzz';
        else $cdprodFin = str_pad($row['PRODFINAL']['CDARVPROD'], 10, 'z');
  
        $rows['PRODINICIAL'] = $cdprodIni;
        $rows['PRODFINAL'] = $cdprodFin;
  
        $idArredondamento = null;      
        if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('ARREDONDAMENTO', $row)) {
          $idArredondamento = $row['ARREDONDAMENTO'];
        } else if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('QTDPROD', $row)) {
          $idArredondamento = ($row['QTDPROD'] === false) ? 'N' : 'S';
        }
        
        /*// if(empty($row['SERVICO'])) $cdservfili = join('_', $this->utilities->getDistinctServicos($row['CDFILCENTPME'], $row['UNIDADE']));
        if (empty($row['SERVICO'])) $cdservfili = null;
        else $cdservfili = is_array($row['SERVICO']) ? join("_", $row['SERVICO']) : $row['SERVICO'];
        
        // if(empty($row['TIPOCARD'])) $tipoCard = join('_', $this->getTipoCard($row));
        if (empty($row['TIPOCARD'])) $tipoCard = null;
        else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
        
        $cdprodIni = isset($row['PRODINICIAL']['CDARVPROD']) ? $row['PRODINICIAL']['CDARVPROD'] : 0;
        if (!(isset($row['PRODFINAL']['CDARVPROD']))) $cdprodFin = 'zzzzzzzzzzz';
        else $cdprodFin = str_pad($row['PRODFINAL']['CDARVPROD'], 10, 'z');
  
        $rows['PRODINICIAL'] = $cdprodIni;
        $rows['PRODFINAL'] = $cdprodFin;*/
  
        $filiais = explode('_', $cdfilial);
        $filiaisExecution = array();
        if (!empty($filiais) && $filiais[0] !== "") {
          $j = 0;
          for($i = 0; $i < intval(count($filiais) / intval(4000 / 5)) + 1; $i++) {
            $filiaisExecution[$i] = array_slice($filiais, $j, intval(4000 / 5));
            $j += intval(4000 / 5);
          }
        } else $filiaisExecution[0] = null;
        
        $servicos = explode('_', $cdservfili);
        $servicosExecution = array();
        if (!empty($servicos) && $servicos[0] !== "") {
          $j = 0;
          for($i = 0; $i < intval(count($servicos) / intval(4000 / 6)) + 1; $i++) {
            $servicosExecution[$i] = array_slice($servicos, $j, intval(4000 / 6));
            $j += intval(4000 / 6);
          }
        } else $servicosExecution[0] = null;
        
        $tipoCardapios = explode('_', $tipoCard);
        $tipoCardExecution = array();
        if (!empty($tipoCardapios) && $tipoCardapios[0] !== "") {
          $j = 0;
          for($i = 0; $i < intval(count($tipoCardapios) / intval(4000 / 11)) + 1; $i++) {
            $tipoCardExecution[$i] = array_slice($tipoCardapios, $j, intval(4000 / 11));
            $j += intval(4000 / 11);
          }
        } else $tipoCardExecution[0] = null;
        
        foreach($tipoCardExecution as $tpCardExecution) {
          if (!empty($tpCardExecution)) $tipoCardProc = join("_", $tpCardExecution);
          else $tipoCardProc = null;
          
          foreach($filiaisExecution as $filialExecution) {
            if (!empty($filialExecution)) $cdfilialProc = join("_", $filialExecution);
            else $cdfilialProc = null;
              
            foreach($servicosExecution as $servicoExecution) {
              if (!empty($servicoExecution)) $cdservfiliProc = join("_", $servicoExecution);
              else $cdservfiliProc = null;
  
              set_time_limit(240);
              ini_set('memory_limit', '3072M');
        
              $connection = $this->entityManager->getConnection();
              $procedureCons = new StoredProcedure($connection, 'PREVISAO_CONSUMO_PME');
    
              $procedureCons->addParam(new Param('P_CDFILCENTPME', Param::PARAM_INPUT, $row['CDFILCENTPME'],   Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_CDTIPOCARD',   Param::PARAM_INPUT, $tipoCardProc,              Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_CDFILIAL',     Param::PARAM_INPUT, $cdfilialProc,              Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_CDSERVFILI',   Param::PARAM_INPUT, $cdservfiliProc,            Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_DTINICIAL',    Param::PARAM_INPUT, $row['DTDE'],           Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_DTFINAL',      Param::PARAM_INPUT, $row['DTATE'],          Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_PEACRESCIMO',  Param::PARAM_INPUT, $row['ACRESCIMO'],      Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_CDPRODUTOINI', Param::PARAM_INPUT, $cdprodIni,             Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_CDPRODUTOFIN', Param::PARAM_INPUT, $cdprodFin,             Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $cdoperador,            Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_DTHRCALCPC',   Param::PARAM_INPUT, date("d/m/Y"),          Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_NRCONSPLAN',   Param::PARAM_INPUT, $nrconsplan,            Param::PARAM_TYPE_STR));
              $procedureCons->addParam(new Param('P_IDARREDOND',   Param::PARAM_INPUT, $idArredondamento, Param::PARAM_TYPE_STR));
              $procedureCons->execute();
            }
          }
        }
    
        return $nrconsplan;
      } catch (\Exception $e) {
        throw $e;
      }
    }
     
    private function getServicos($row){
      if(empty($row['UNIDADE'])) $unidade = 'T';
      else $unidade = join("_", $row['UNIDADE']);
      $rows = $this->utilities->getServicos($row['CDFILCENTPME'], $unidade);
      $servicos = [];
      $filteredRows = [];
      if(empty($row['SERVICO'])) $filteredRows = $rows;
      else {
        if(!is_array($row['SERVICO'])) $row['SERVICO'] = [$row['SERVICO']];
        foreach($row['SERVICO'] as $a){
          foreach($rows as $b){
            if($a == $b['CDSERVFILI']) array_push($filteredRows, $b);
          } 
        } 
      }
      foreach($filteredRows as $serv){
        array_push($servicos, $serv['CDFILIAL'].$serv['CDSERVFILI']);
      }
      return $servicos;
    }

    private function getUnidades($row){
      $rows = $this->utilities->getUnidades($row['CDFILCENTPME'], "N");
      $unidades = [];
      foreach($rows as $unid){
        array_push($unidades, $unid['CDFILIAL']);
      }
      return $unidades;
    }
    
    private function getUnidadesAgrup($row){
      $rows = $this->utilities->getUnidadesAgrup($row['CDFILCENTPME'], $row['GRUPFILI']);
      $unidades = [];
      foreach($rows as $unid){
        array_push($unidades, $unid['CDFILIAL']);
      }
      return $unidades;
    }

    private function getTipoCard($row){
      $rows = $this->utilities->getTipoCard($row['CDFILCENTPME'], "S");
      $tiposCard = [];
      foreach($rows as $tipo){
        array_push($tiposCard, $tipo['CDTIPOCARD']);
      }
      return $tiposCard;
    }
    
    public function insertIntoLogprevconspme($row, $nrconsplan) {
      try {
        if(empty($row['UNIDADE'])) $cdfilial = 'T';
        else $cdfilial = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];
        
        if(empty($row['SERVICO'])) $cdservfili = 'T';
        else $cdservfili = is_array($row['SERVICO']) ? join("_", $row['SERVICO']) : $row['SERVICO'];
        
        if(empty($row['TIPOCARD'])) $tipoCard = 'T';
        else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
        
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();
        
        // $this->connection->beginTransaction();
        
        $query = "INSERT INTO LOGPREVCONSPME(CDFILCENTPME, CDTIPOCARD, CDSERVFILI, CDFILIAL, CDOPERADOR, DTHRCALCPR, DTINICIALPC , DTFINALPC , CDPRODINICPC , CDPRODFINAPC , PEACRESCIMPR, NRCONSPLANPC )
                        SELECT T.CDFILCENTPME, T.CDTIPOCARD, S.CDSERVFILI, F.CDFILIAL, :P_CDOPERADOR, :P_DTHRCALCPR, :P_DTINICIALPC, :P_DTFINALPC, :P_CDPRODINICPC ,
                            :P_CDPRODFINAPC ,  :P_PEACRESCIMPR,  :P_NRCONSPLANPC 
                          FROM TIPOCARD T
                         INNER JOIN SERVTIPOCARD S ON T.CDFILCENTPME = S.CDFILCENTPME 
                            AND T.CDTIPOCARD = S.CDTIPOCARD
                            AND ( INSTR(:P_CDSERVFILI, S.CDSERVFILI) > 0 OR :P_CDSERVFILI = 'T' )
                         INNER JOIN FILITIPOCARD F ON F.CDFILCENTPME = T.CDFILCENTPME 
                            AND F.CDTIPOCARD = T.CDTIPOCARD 
                            AND F.IDTCARATFILI = 'S'
                            AND ( INSTR(:P_CDFILIAL, F.CDFILIAL) > 0 OR :P_CDFILIAL = 'T' ) 
                         WHERE T.CDFILCENTPME = :P_CDFILCENTPME
                           AND T.IDTPCARDATIV = 'S'
                           AND ( INSTR(:P_CDTIPOCARD, T.CDTIPOCARD) > 0 OR :P_CDTIPOCARD = 'T' )";
          
        $params = array(
          'P_DTFINALPC'    => $row['DTATE'], 
          'P_CDFILIAL'     => $cdfilial,
          'P_CDOPERADOR'   => $cdoperador,
          'P_CDPRODFINAPC' => $row['PRODFINAL'] !== null ? $row['PRODFINAL']["CDPRODUTO"] : '0',
          'P_CDPRODINICPC' => $row['PRODINICIAL'] !== null ? $row['PRODINICIAL']["CDPRODUTO"] : 'Z',
          'P_NRCONSPLANPC' => $nrconsplan,
          'P_PEACRESCIMPR' => $row['ACRESCIMO'],
          'P_CDSERVFILI'   => $cdservfili,
          'P_CDFILCENTPME' => $row['CDFILCENTPME'],
          'P_DTHRCALCPR'   => date("d/m/Y H:i:s"),
          'P_DTINICIALPC'  => $row['DTDE'],
          'P_CDTIPOCARD'   => $tipoCard,
        );
        $this->connection->prepare($query)->execute($params);
        // $this->connection->commit();
    } catch (\Exception $e) {
    	// $this->connection->rollback();
	  }
  }
  
  private function geraListaServicos($row) {
    $sql = "INSERT INTO LISTA (CDLISTA, NRLISTA, NRORG)
              SELECT CDFILIAL || CDSERVFILI AS CDLISTA, :NRLISTA AS NRLISTA, NRORG 
                FROM ( SELECT DISTINCT S.CDFILCENTPME, SE.CDFILIAL, SE.CDSERVFILI, SE.NMSERVICO, SE.NRORG 
                FROM SERVICO SE 
                  JOIN SERVTIPOCARD S ON S.CDFILCENTPME = :CDFILCENTPME AND SE.CDSERVFILI = S.CDSERVFILI
                  JOIN FILITIPOCARD F ON S.CDFILCENTPME = F.CDFILCENTPME AND S.CDTIPOCARD = F.CDTIPOCARD AND F.CDFILIAL = SE.CDFILIAL ";
    
    if (!empty($row['GRUPFILI'])) $sql .= " JOIN FILGRUPFILI FG ON FG.CDFILIAL = SE.CDFILIAL ";
    
    $nrorg = $this->environment->getNrOrg();
    
    $nrlista = $this->newCode->getCodeByTableName('LISTA', $nrorg);
    
    $params = array(
        "NRLISTA"      => $nrlista,
        "CDFILCENTPME" => $row['CDFILCENTPME'],
        // "CDFILIAL"     => $unidade,
        // "CDSERVFILI" => $cdservfili,
        // "CDTIPOCARD" => $cdtipocard,
        // "CDGRUPSERV" => $cdgrupserv,
        // "CDGRUPFILI" => $cdgrupfili,
      );
      
    $wheres = [];
    
    if(!empty($row['UNIDADE'])) { 
      $wheres[] = "INSTR(:CDFILIAL, SE.CDFILIAL) <> 0";      
      $unidade = join("_", $row['UNIDADE']);
      $params['CDFILIAL'] = $unidade;
    }
    
    if(!empty($row['GRUPFILI'])) { 
      $wheres[] = "INSTR(:CDGRUPFILI, FG.CDGRUPFILI) <> 0";      
      $params['CDGRUPFILI'] = $row['GRUPFILI'];
    }
    
    if (!empty($row['SERVICO'])) {
      $wheres[] = "INSTR(:CDSERVFILI, SE.CDSERVFILI) <> 0";
      if (is_array($row['SERVICO']))  $cdservfili = join("_", $row['SERVICO']);
      else $cdservfili = $row['SERVICO'];
      $params['CDSERVFILI'] = $cdservfili;
    }
    
    if (!empty($row['GRUPSERV'])) {
      $wheres[] = "INSTR(:CDGRUPSERV, SE.CDGRUPSERV) <> 0";
      if (is_array($row['GRUPSERV']))  $cdgrupserv = join("_", $row['GRUPSERV']);
      else $cdgrupserv = $row['GRUPSERV'];
      $params['CDGRUPSERV'] = $cdgrupserv;
    }
    
    if (!empty($row['TIPOCARD'])) {
      $wheres[] = "INSTR(:CDTIPOCARD, S.CDTIPOCARD) <> 0";
      $cdtipocard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
      $params['CDTIPOCARD'] = $cdtipocard;
    }
    
    if (!empty($wheres)) $sql   .= "    WHERE ".implode(" AND ", $wheres);
    
    $sql .= ")";
    
    $stmt = $this->entityManager->getConnection()->prepare($sql);
    $stmt->execute($params);
    
    return $nrlista;
  }
  
  private function geraListaTipoCard($row) {
    if(empty($row['TIPOCARD'])) $cdtipocard = 'T';
    else $cdtipocard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
    
    $nrorg = $this->environment->getNrOrg();
    
    $nrlista = $this->newCode->getCodeByTableName('LISTA', $nrorg);

    $sql = "INSERT INTO LISTA (CDLISTA, NRLISTA, NRORG)
              SELECT CDTIPOCARD, :NRLISTA AS NRLISTA, NRORG FROM TIPOCARD WHERE CDFILCENTPME = :CDFILCENTPME AND (NRPASTATCARD = :NRPASTATCARD OR :NRPASTATCARD IS NULL) 
              AND ( INSTR(:CDTIPOCARD, CDTIPOCARD) <> 0 OR ( :CDTIPOCARD = 'T' ) )
              ORDER BY CDTIPOCARD";
    $stmt = $this->entityManager->getConnection()->prepare($sql);
    $stmt->execute(
      array(
        "NRLISTA"      => $nrlista,
        "CDFILCENTPME" => $row['CDFILCENTPME'],
        "CDTIPOCARD" => $cdtipocard,
        "NRPASTATCARD"     => null
      )
    );
    
    return $nrlista;
  }
  
  /*
  public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
      try {
          $row = $request->getRow();
          if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('LISTASERVICO', $row) && !empty($row['LISTASERVICO'])) {
            $this->lista->remove($row['LISTASERVICO']);
          }
          if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('LISTATIPOCARD', $row) && !empty($row['LISTATIPOCARD'])) {
            $this->lista->remove($row['LISTATIPOCARD']);
          }
          if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('LISTASUBGRPROD', $row) && !empty($row['LISTASUBGRPROD'])) {
            $this->lista->remove($row['LISTASUBGRPROD']);
          }
      } catch (\Exception $e) {
        $response->setError(new Error($e->getMessage(), 1));
      }
  }
  */

}